<template>
  <div v-click-outside="hideDropdown" :class="['wrapper', {'input-focused': focused, 'invalid': invalid, 'readonly': readonly}]">
    <label :for="id" :class="['base-label', {'base-label--hidden': !value}]">
      {{ label }}
    </label>
    <div
      class='base-input-wrapper'
    >
      <input
        :id="id"
        class="base-input"
        v-bind="$attrs"
        :placeholder="$attrs.placeholder"
        :readonly='readonly'
        @focus="focusHandler"
        @input="inputHandler"
        :value="value"
        @blur="blurHandler"
      >
      <p v-show='invalid' class='invalid-text'>Required field</p>
    </div>
    <div
      v-show="isDropdownOpen"
      class="list-selector___dropdown"
      :id='idDropdown'
    >
      <ul v-show='filterOff'>
        <li
          v-for="item in list"
          :key="item.id"
          @click="onItemClick(item)"
        >
          {{ item[itemKey] }}
        </li>
      </ul>
      <ul v-show='!filterOff'>
        <li
          v-for="item in filteredList"
          :key="item.id"
          @click="onItemClick(item)"
        >
          {{ item[itemKey] }}
        </li>
        <li v-show="!filteredList.length" class="empty">
          Nothing found
        </li>
      </ul>
    </div>
  </div>
</template>

<script>
import Scrollbar from 'smooth-scrollbar'
import ClickOutside from "vue-click-outside";
import {debounce}  from "../../helpers/debounce";

export default {

  directives: {
    ClickOutside,
  },
  props: {
    value: {
      type: String,
      default: ''
    },

    filterOff: {
      type: Boolean,
      default: false,
    },

    id: {
      type: String,
      default: ''
    },

    idDropdown: {
      type: String,
      default: ''
    },

    label: {
      type: String,
      default: ''
    },

    invalid: {
      type: Boolean,
      default: false
    },

    list: {
      type: Array
    },

    itemKey: {
      type: String
    },

    readonly: {
      type: Boolean,
      default: false
    }
  },

  data() {
    return {
      focused: false,
      isDropdownOpen: false,
      selectedListItem: {},
      filteredList: this.list,
      searchValue: '',
      debouncedSearchItem: null,
    }
  },

  computed: {
    valueNotEmpty() {
      return this.filteredList.length > 0
    }
  },


  watch: {
    value() {
      this.debouncedSearchItem()
    },

    selectedListItem() {
      this.$emit('selected', this.selectedListItem)
    }
  },

  created() {
    this.debouncedSearchItem = debounce(this.getSearchItem, 300);
  },

  mounted() {
    this.$nextTick(() => {
      Scrollbar.init(document.querySelector(`#${this.idDropdown}`), { alwaysShowTracks: true });
    })
  },

  methods: {
    inputHandler(event) {
      this.$emit('input', event.target.value)
      this.isDropdownOpen = true
    },

    focusHandler() {
      this.focused = true
      this.isDropdownOpen = true
    },

    blurHandler() {
      this.focused = false
    },

    hideDropdown() {
      this.isDropdownOpen = false
    },

    onItemClick(item) {
      this.selectedListItem = item
      this.isDropdownOpen = false
    },

    getSearchItem() {
      this.filteredList = this.list.filter(item => item[this.itemKey].toLowerCase().includes(this.value.toLowerCase()))
    }
  },
}
</script>

<style lang='scss' scoped>

.wrapper {
  position: relative;
}

.base-input-wrapper {
  border-bottom: 2px solid #3A4675;
  width: 100%;
  padding: 18px 0 18px;
  transition: all 0.5s;
}

.base-input {
  width: 100%;
  height: 25px;
  margin: 0;
  border: none;
  outline: none;
  padding: 0;
  font-size: 20px;
  color: #FFFFFF;
  background-color: transparent;
  background-repeat: no-repeat;
  background-image: url("../../assets/img/vector.svg");
  background-position: center right;

  @media (max-width: 767px) {
    font-size: 18px;
  }
}

.base-input::placeholder ,{
  color: rgba(255, 255, 255, 0.45);
  font-size: 20px;
  font-weight: 300;

  @media (max-width: 767px) {
    font-size: 18px;
  }
}

.base-label {
  font-weight: 300;
  font-size: 16px;
  color: rgba(255, 255, 255, 0.45);
  opacity: 1;
  transition: all 0.5s;

  &--hidden {
    opacity: 0;
  }
}

.list-selector___dropdown {
  max-height: 150px;
  width: -webkit-fill-available;
  overflow-y: auto;
  position: absolute;
  background: #0E1B4E;
  border: 2px solid #3A4675;
  border-radius: 4px;
  margin-top: 2px;
  z-index: 2;
}

.list-selector___dropdown ul {
  list-style: none;
  margin: 0;
  padding: 0;
}

.list-selector___dropdown li {
  padding: 6px;
  cursor: pointer;
  color: white;
}

.list-selector___dropdown li:hover {
  background-color: #3A467566;
}

.empty {
  text-align: center;
  font-size: 16px;
  color: white;
}

li.empty:hover {
  background-color: transparent;
}

.input-focused {
  .base-input-wrapper {
    border-bottom: 2px solid #438AF9;
  }

  label {
    color: #438AF9;
  }
}

.invalid {
  .invalid-text {
    color: #FA5D2C;
    position: absolute;
    bottom: 48px;
    left: 0;
    font-size: 14px;
  }
}

.readonly {
  pointer-events: none;
  opacity: 0.5;
}
</style>
